/**
 * 
 */
package de.pdark.decentxml;

import java.io.IOException;
import java.io.StringWriter;
import java.io.Writer;

import de.pdark.decentxml.XMLTokenizer.Type;

public class BasicNode implements Node
{
    private XMLTokenizer.Token token;
    private Type type;
    private String value;
    
    public BasicNode (XMLTokenizer.Token token)
    {
        this.token = token;
        this.type = token.getType();
    }
    
    public BasicNode (Type type, String text)
    {
        this.type = type;
        this.value = text;
    }

    public Type getType ()
    {
        return type;
    }
    
    public int getStartOffset ()
    {
        return token.getStartOffset ();
    }
    
    public int getEndOffset ()
    {
        return token.getEndOffset ();
    }
    
    public String getValue ()
    {
        return value == null ? token.getText () : value;
    }
    
    public void setValue (String value)
    {
        this.value = value;
    }
    
    public void toXML (Writer writer) throws IOException
    {
        writer.append (getValue ());
    }
    
    public String toXML ()
    {
        return toXML (this);
    }
    
    @Override
    public String toString ()
    {
        return toXML ();
    }

    public static String toXML (Node n)
    {
        StringWriter buffer = new StringWriter ();
        try
        {
            n.toXML (buffer);
        }
        catch (IOException e) // Note: this code will never be executed
        {
            throw new RuntimeException ("Should not happen", e);
        }
        return buffer.toString ();
    }
}