/**
 * 
 */
package de.pdark.decentxml;

import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.List;

import de.pdark.decentxml.XMLTokenizer.Type;

public class Document implements Node
{
    private List<Node> nodes = new ArrayList<Node> ();
    private Element rootNode;
    
    public Document ()
    {
        // Do nothing
    }
    
    public void addNode (Node node)
    {
        if (node instanceof Element)
        {
            Element e = (Element)node;
            if (rootNode != null)
                throw new XMLParseException ("Only one root element allowed per document", e.getStartToken ());
            
            rootNode = e;
        }
        
        nodes.add (node);
    }
    
    public Element getRootElement ()
    {
        return rootNode;
    }
    
    public void toXML (Writer writer) throws IOException
    {
        for (Node n: nodes)
            n.toXML (writer);
    }

    public String toXML ()
    {
        return BasicNode.toXML (this);
    }
    
    public Type getType ()
    {
        return Type.DOCUMENT;
    }
    
    public Node remove (int index)
    {
        return nodes.remove (index);
    }
    
    public Node get (int index)
    {
        return nodes.get (index);
    }
    
    public boolean remove (Node n)
    {
        return nodes.remove (n);
    }

}