package de.pdark.decentxml;

import java.io.ByteArrayInputStream;

import junit.framework.TestCase;

public class JoinedInputStreamTest extends TestCase
{
    public void testEmpty () throws Exception
    {
        JoinedInputStream jin = new JoinedInputStream ();
        assertEquals (-1, jin.read ());
        jin.close ();
    }
    
    public void testSingleStream () throws Exception
    {
        JoinedInputStream jin = new JoinedInputStream ();
        jin.add (new ByteArrayInputStream (" ".getBytes ()));
        
        assertEquals (32, jin.read ());
        assertEquals (-1, jin.read ());
        jin.close ();
    }
    
    public void testClose () throws Exception
    {
        JoinedInputStream jin = new JoinedInputStream ();
        jin.add (new ByteArrayInputStream (" ".getBytes ()));
        jin.close ();
    }
}
